# coding=utf-8
from osv import osv, fields

import time
import netsvc
from mx import DateTime

# Contact Type
class res_partner_address_category(osv.osv):
	_name = 'res.partner.address.category'
	_order = 'name ASC'
	_description = 'Extended Contact Category'
	_columns = {
		'name':  fields.char('Category Name', size=32, required=True, select=True),
		'key':  fields.char('Internal Name', size=32, required=True),
	}

	# Não deixa excluir valores padrão do ERP.
	def unlink(self, cr, uid, ids):
		for t in self.browse(cr,uid,ids):
			if t.id <= 5:
				raise osv.except_osv('Error','Não é possível excluir Contact Category id=%d!\nParâmetro nativo do OpenERP.' % t.id)
		return osv.osv.unlink(self, cr, uid, ids)
			
res_partner_address_category()

class res_partner_address(osv.osv):
	_inherit = "res.partner.address"

	_columns = {
		'status': fields.selection([('ativo','Ativo'),('inativo','Inativo')],'Status'),
		'street2': fields.char('Bairro', size=128),
	}
	_defaults = {
		'status': lambda *a: 'ativo',
	}
res_partner_address()

class res_partner_address(osv.osv):
	_inherit = 'res.partner.address'

	# Redefine o campo Type para que posso ser adicionado novos tipos de contatos.	
	def _field_type(self, cr, uid, data):
		cr.execute('SELECT key,name FROM res_partner_address_type ORDER BY name ASC')
		res = cr.fetchall()
		return res
	
	_columns = {
		#'type': fields.selection(_field_type,'Contact Type'),
		'category': fields.many2many('res.partner.address.category', 'res_partner_address_category_rel', 'contact_id', 'category_id', 'Contact Categories'),		
	}
	_defaults = {
		'type': lambda *a: 'default',
	}
res_partner_address()
