# coding=utf-8
from osv import fields, osv
import time

class product_template(osv.osv):
	_inherit = "product.template"

	_columns = {
		#Produtos que não devem gerar Procurements. Ex.: Software gravado no CD.
		'procure_method': fields.selection([('make_to_stock','Make to Stock'),('make_to_order','Make to Order'), ('ignore','Ignore')], 'Procure Method', required=True),

		#Muda o campo para string para ficar menor na interface.
		'description_purchase': fields.char('Purchase Description', size=256,),
	}

	_defaults = {
		'description': lambda *a: 'Revisor do Código: ?',
	}
product_template()



class pricelist_partnerinfo(osv.osv):
	_inherit = 'pricelist.partnerinfo'
	_order = 'date DESC'
	
	# Cria campo de data para guardar a modificação
	_columns = {
		'date': fields.date('Data Atualização'),
	}
	_defaults = {
		'date': lambda *a: time.strftime('%Y-%m-%d'),
	}	
	_order = 'min_quantity asc'
pricelist_partnerinfo()

class product_supplierinfo(osv.osv):
	_inherit = "product.supplierinfo"

	# Cria campo função para visualizar o campo de data criado em 'pricelist.partnerinfo'
	def _field_pricelist_date(self, cr, uid, ids, prop, unknow_none,unknow_dict):
		res = {}
		for line in self.browse(cr,uid,ids):
			if line.pricelist_ids:
				res[line.id] = 0
				for pricelist in line.pricelist_ids:
					if res[line.id] < pricelist.date:
						res[line.id] = pricelist.date
			else:
				res[line.id] = False
		return res
		
	_columns = {
		#'product_code': fields.char('Partner product reference', size=64, select=True),
		'pricelist_date': fields.function(_field_pricelist_date, method=True, string='Data Atualização', type="date"),
	}
product_supplierinfo()
