# coding=utf-8
import wizard
import netsvc
import time
import pooler
from osv import osv

class wiz_res_partner_get_emails(wizard.interface):
	_filter_form = '<?xml version="1.0"?><form string="Localizar e-mails">\
		<separator string="Partner Category" colspan="2"/>\
		<separator string="Contact Type" colspan="2"/>\
		<field name="partner_category" nolabel="1" colspan="2"/>\
		<field name="contact_type" nolabel="1" colspan="2"/>\
		</form>'
	_filter_fields = {
		'partner_category': {'string': 'Category', 'type': 'many2many', 'relation': 'res.partner.category'},
		'contact_type':  {'string': 'Type', 'type': 'many2many', 'relation': 'res.partner.address.type'},
	}
	_result_form = '<?xml version="1.0"?><form string="Localizar e-mails">\
		<label string="Resultado da pesquisa:                                                "/>\
		<field name="result" colspan="4" nolabel="1"/>\
		</form>'
		
	_result_fields = {
		'result': {'string': 'Resultado', 'type': 'text', 'default': ''},
	}
	
	
	def _get_emails (self, cr, uid, data, context):
		cats = data['form']['partner_category'][0][2]
		types = data['form']['contact_type'][0][2]

		if cats:
			cats = [str(p) for p in cats]
			cats = ','.join(cats)
			cats = ' AND t1.id IN (SELECT partner_id FROM res_partner_category_rel WHERE category_id IN (%s))' % (cats)
		else:
			cats = ''
			
		if types:
			cr.execute('SELECT key FROM res_partner_address_type WHERE id IN (%s)' % ','.join([str(p) for p in types]))
			types = cr.fetchall()
			types = ["'"+p[0]+"'" for p in types]
			types = ' AND t2.type IN (%s)' % ','.join(types)
		else:
			types = ''
		
		
		sql = 'SELECT t2.name, t2.email FROM res_partner AS t1, res_partner_address AS t2 WHERE t2.partner_id=t1.id AND NOT t2.email IS NULL %s %s' % (cats,types)
		print sql
		cr.execute(sql)
		emails = cr.dictfetchall()
		if emails:
			value = ''
			for e in emails:
				value += '%s<%s>;' % (e['name'],e['email'])
		else:
			value = 'Não foi encontrado nenhum e-mail com o critério selecionado.'
		return {'result': value}
		
	states = {
		'init': {
			'actions': [],
			'result': {'type': 'form', 'arch':_filter_form, 'fields':_filter_fields, 'state':[('end','Cancelar'),('done','Localizar e-mails')]}
		},
		'done': {
			'actions': [_get_emails],
			'result': {'type': 'form', 'arch':_result_form, 'fields':_result_fields, 'state':[('end','Fechar')]}
		},
	}
wiz_res_partner_get_emails('res.partner.get.emails')
