# coding=utf-8
import wizard
import netsvc
import time
import pooler

from osv import osv

def _moves_verify (self, cr, uid, data, context):
	product = pooler.get_pool(cr.dbname).get('product.product').browse(cr, uid, data['ids'], [])[0]
		
	cr.execute("SELECT id,name FROM stock_location")
	locations_name = {}
	locs = cr.dictfetchall()
	for loc in locs:
		locations_name[loc['id']] = loc['name']

	cr.execute("SELECT id,lot_stock_id,name FROM stock_warehouse")
	warehouses = cr.fetchall()
	for warehouse in warehouses:
		lines = []
		lines.append(' # Warehouse: %s' % warehouse[2])

		stock_locations = [warehouse[1]]

		def _get_childs_locations (cr, location):
			cr.execute("SELECT id FROM stock_location WHERE location_id=%i" % location)
			locations = cr.fetchall()
			for loc in locations:
				stock_locations.append(loc[0])
				_get_childs_locations (cr, loc[0])
				
		_get_childs_locations (cr, warehouse[1])
		
		# Moves Reais
		cr.execute("SELECT t1.date_planned, t1.name, t1.product_qty, t1.location_id, t1.location_dest_id, t1.state, t2.factor FROM stock_move AS t1, product_uom AS t2 WHERE t1.product_uom=t2.id AND state = 'done' AND product_id=%i ORDER BY date_planned ASC" % (product.id))
		moves = cr.dictfetchall()

		sum = 0
		lines.append(' Saldo Inicial: 0.00')	
		for move in moves:			
			if move['location_id'] in stock_locations and move['location_dest_id'] not in stock_locations:
				qty = move['product_qty'] * (1/move['factor'])
				sum -= qty
				sum_text = '%.2f' % sum
				lines.append(' %s:  -%.2f (%s): %s  Saldo: %.2f  [%s => %s]' % (move['date_planned'],qty,move['state'],move['name'],sum,locations_name[move['location_id']],locations_name[move['location_dest_id']]))
			
			if move['location_id'] not in stock_locations and move['location_dest_id'] in stock_locations:
				qty = move['product_qty'] * (1/move['factor'])
				sum += move['product_qty'] * (1/move['factor'])
				lines.append(' %s:  +%.2f (%s): %s  Saldo: %.2f  [%s => %s]' % (move['date_planned'],qty,move['state'],move['name'],sum,locations_name[move['location_id']],locations_name[move['location_dest_id']]))

		lines.append(' Saldo Final (Real): %.2f' % sum)	
			
		all_moves = '\n'.join(lines) or ''

		# Moves Virtuais
		lines = []
		lines.append(' # Warehouse: %s' % warehouse[2])

		cr.execute("SELECT t1.date_planned,t1.name,t1.product_qty,t1.location_id,t1.location_dest_id,t1.state,t2.factor FROM stock_move AS t1, product_uom AS t2\
		WHERE t1.product_uom=t2.id AND NOT state IN ('done','cancel','draft') AND product_id=%i ORDER BY date_planned ASC" % (product.id))
		moves = cr.dictfetchall()
		lines.append(' Saldo Inicial: %.2f' % sum)	
		for move in moves:
			if move['location_id'] in stock_locations and move['location_dest_id'] not in stock_locations:
				qty = move['product_qty'] * (1/move['factor'])
				sum -= qty
				sum_text = '%.2f' % sum
				lines.append(' %s:  -%.2f (%s): %s  Saldo: %.2f  [%s => %s]' % (move['date_planned'],qty,move['state'],move['name'],sum,locations_name[move['location_id']],locations_name[move['location_dest_id']]))
			
			if move['location_id'] not in stock_locations and move['location_dest_id'] in stock_locations:
				qty = move['product_qty'] * (1/move['factor'])	
				sum += qty
				lines.append(' %s:  +%.2f (%s): %s  Saldo: %.2f  [%s => %s]' % (move['date_planned'],qty,move['state'],move['name'],sum,locations_name[move['location_id']],locations_name[move['location_dest_id']]))

		lines.append(' Saldo Final (Virtual): %.2f' % sum)	
		virtual_moves = '\n'.join(lines) or ''	

	return {'moves': all_moves, 'virtual_moves': virtual_moves}

_move_fields = {
	'moves': {'string':'', 'type':'text', 'default': 'default', 'readonly':False},
	'virtual_moves': {'string':'', 'type':'text', 'default': 'default', 'readonly':False},
}

class product_moves_states(wizard.interface):
	move_form = '''<?xml version="1.0"?>
		<form string="Product Stock Moves">
			<separator string="Done Stock Moves                                 	                                                                                                                      																   " colspan="4"/>
			<field name="moves" nolabel="1"/>
			<separator string="Virtual Stock Moves	                                                                                                                      																   " colspan="4"/>
			<field name="virtual_moves" nolabel="1"/>
		</form>'''

	states = {
		'init': {
			'actions': [_moves_verify],
			'result': {'type': 'form', 'arch': move_form, 'fields': _move_fields, 'state':[('end','Fechar')]}
		},
	}
product_moves_states('product.product.moves')
