# coding=utf-8
import wizard
import netsvc
import time
import pooler
from osv import osv


def _get_wkf_activity (cr,state_name,model_name):
	cr.execute("SELECT id FROM wkf_activity WHERE name='%s' AND wkf_id=(SELECT id FROM wkf WHERE osv='%s')" % (state_name,model_name))
	if cr.rowcount > 0:
		return cr.fetchone()[0]
	else:
		raise osv.except_osv('UserError',"state '%s' doesn't exists in '%s'" % (state_from,obj._name))

def _get_wkf_instance (cr,obj_id,model_name):
	cr.execute("SELECT id FROM wkf_instance WHERE res_id=%i AND res_type='%s'" % (obj_id,model_name))
	if cr.rowcount > 0:
		return cr.fetchone()[0]
	else:
		return False

def _change_state (cr,uid,obj,state_from,state_to,state):
	# ex: _change_state(cr,uid,production,'picking','draft','complete')
	obj.write(cr, uid, [obj.id],{'state': state_to})
	inst_id = _get_wkf_instance(cr,obj.id,obj._name)
	
	from_act_id = _get_wkf_activity (cr,state_from,obj._name)		
	to_act_id = _get_wkf_activity (cr,state_to,obj._name)
	
	cr.execute("UPDATE wkf_workitem SET act_id=%i, subflow_id=NULL, state='%s' WHERE act_id=%i AND inst_id=%i" % (to_act_id, state, from_act_id, inst_id))
	cr.commit()

def _get_product (cr, uid, product_id):		
	prod = {}	
	product = pooler.get_pool(cr.dbname).get('product.product').browse(cr, uid, [product_id], [])[0]
	prod['name'] = product.product_tmpl_id.name
	prod['supply_method'] = product.product_tmpl_id.supply_method
	prod['procure_method'] = product.product_tmpl_id.procure_method
	prod['id'] = product.id
	prod['code'] = product.code
	prod['virtual_available'] = product.virtual_available
	prod['stock_available'] = product.qty_available
	prod['draft'] = 0

	return prod

def _delete_purchase (cr, uid,purchase_id):
	cr.execute("DELETE FROM purchase_order WHERE id=%d", [purchase_id])
	instance = _get_wkf_instance(cr,purchase_id,'purchase_order')
	if instance:
		cr.execute("DELETE FROM wkf_instance WHERE id=%d", [instance])
	cr.commit()
def _delete_production (cr, uid,production_id, delete_self = True, level=0):
	production = pooler.get_pool(cr.dbname).get('mrp.production').browse(cr, uid, [production_id], [])[0]
	
	# Procurements
	cr.execute("SELECT id,move_id,procure_method,product_id FROM mrp_procurement WHERE production_id=%d", [production.id] )
	procurements = cr.dictfetchall()
	
	for procurement in procurements:
		product = _get_product(cr, uid,procurement['product_id'])
		
		# Make_to_STOCK
		if procurement['procure_method'] == 'make_to_stock':
			pass
			
		# Make_to_ORDER
		elif procurement['procure_method'] == 'make_to_order':
			
			if product['supply_method']  == 'buy':
				#Procurar a order de compra automática
				cr.execute("SELECT id,state,name FROM purchase_order WHERE procurement_id=%d AND EXISTS (SELECT id FROM purchase_order_line WHERE product_id=%d AND purchase_order.id = order_id) LIMIT 1",  [procurement['id'],  product['id']] )
				if cr.rowcount>0:
					purchase_order = cr.dictfetchone()
					# Ordem de compra pode ser desfeita
					if purchase_order['state']  == 'draft':
						_delete_purchase(cr,uid,purchase_order['id'])
							
			elif product['supply_method']  == 'produce':
				#Procurar a ordem de produção automática
				cr.execute("SELECT id,state FROM mrp_production WHERE procurement_id=%d AND product_id=%d  LIMIT 1",  [procurement['id'],  product['id']]  )
				if cr.rowcount>0:
					production_order = cr.dictfetchone()
					# Ordem de produção pode ser desfeita							
					if production_order['state']  in ['draft', 'confirmed', 'ready']:
						_delete_production (cr, uid,production_order['id'], True, level+1)
							
		cr.execute("DELETE FROM stock_move WHERE id=%d", [procurement['move_id']] )						
		cr.execute("DELETE FROM mrp_procurement WHERE id=%d", [procurement['id']] )
		cr.execute("DELETE FROM wkf_instance WHERE id=%d", [_get_wkf_instance(cr,procurement['id'],'mrp.procurement')] )
		cr.commit()
		
	# Moves
	cr.execute("SELECT id FROM stock_move WHERE production_id=%d LIMIT 1", [production.id])
	move = cr.fetchone()
	if len(move)==1:
		cr.execute("DELETE FROM stock_move WHERE move_dest_id=%d", [move[0]])		
		cr.execute("DELETE FROM stock_move WHERE id=%d", [move[0]])

	# Products Lines
	cr.execute('DELETE FROM mrp_production_product_line WHERE production_id=%d', [production.id])
	cr.execute('DELETE FROM mrp_production_workcenter_line WHERE production_id=%d', [production.id])
	
	# Packing
	cr.execute("SELECT id FROM stock_picking WHERE id=%d", [production.picking_id.id])
	rows = cr.fetchall()
	for row in rows:
		cr.execute("DELETE FROM stock_picking WHERE id=%d", [row[0]])				
		cr.execute("DELETE FROM wkf_instance WHERE id=%d", [_get_wkf_instance(cr,row[0],'stock.picking')] )
	
	# Production itself
	if  delete_self :
		cr.execute("DELETE FROM mrp_production WHERE id=%d", [production.id])				
		cr.execute("DELETE FROM wkf_instance WHERE id=%d", [_get_wkf_instance(cr,production.id,'mrp.production')] )
	cr.commit()
		
def _undo_production (self, cr, uid, data, context):
	production_id = data['ids'][0]
	production = pooler.get_pool(cr.dbname).get('mrp.production').browse(cr, uid, [production_id], [])[0]
	
	if production.state != 'confirmed':
		raise osv.except_osv('UserError','Production not confirmed!')
		
	_change_state(cr,uid,production,'picking','draft','complete')
	_delete_production(cr, uid, production_id, False)

	return {}
	
def _verify_demand_from_stock (cr, uid, product_id,  production_qty, move_created_ids):
	cr.execute("SELECT lot_stock_id FROM stock_warehouse")
	warehouses = cr.dictfetchall()

	real_stock = product_id.qty_available

	stock_locations = []
	for warehouse in warehouses:
		stock_locations = [str(warehouse['lot_stock_id'])]		
		def _get_childs_locations (cr, location):
			cr.execute("SELECT id FROM stock_location WHERE location_id=%i" % location)
			locations = cr.dictfetchall()
			for loc in locations:
				stock_locations.append(loc['id'])
				_get_childs_locations (cr, loc['id'])
				
		_get_childs_locations (cr, warehouse['lot_stock_id'])
	
	
	cr.execute("SELECT id,name FROM stock_location")
	locations_name = {}
	locs = cr.dictfetchall()
	for loc in locs:
		locations_name[loc['id']] = loc['name']
		
	# Coleta os moves virtuais do produto

	if move_created_ids:
		where = ' AND NOT t1.id IN (%s) ' % move_created_ids
	else:
		where = ''

	cr.execute("SELECT t1.id, t1.date_planned, t1.name, t1.product_qty, t1.location_id, t1.location_dest_id, t1.state, t2.factor FROM stock_move AS t1, product_uom AS t2 WHERE t1.location_id <> t1.location_dest_id AND t1.product_uom=t2.id AND t1.state <> 'done' AND t1.product_id=%i "+where+" ORDER BY t1.date_planned ASC", [product_id,])
	moves = cr.dictfetchall()
	lines = []
	sum = 0

	for move in moves:

		if move['location_id'] in stock_locations and move['location_dest_id'] not in stock_locations:
			qty = move['product_qty'] * (1/move['factor'])
			sum -= qty
			sum_text = '%.2f' % sum
			lines.append(' %s:  -%.2f (%s): %s  Saldo: %.2f  [%s => %s]' % (move['date_planned'],qty,move['state'],move['name'],sum,locations_name[move['location_id']],locations_name[move['location_dest_id']]))
		
		if move['location_id'] not in stock_locations and move['location_dest_id'] in stock_locations:
			qty = move['product_qty'] * (1/move['factor'])	
			sum += qty
			lines.append(' %s:  +%.2f (%s): %s  Saldo: %.2f  [%s => %s]' % (move['date_planned'],qty,move['state'],move['name'],sum,locations_name[move['location_id']],locations_name[move['location_dest_id']]))

	if len(lines) > 0:
		if (real_stock+sum) < 0:
			lines = ['CUIDADO AO DESFAZER! Estoque virtual ficará negativo!\n'] + lines

		lines.append('\n   Total moves virtuais:  %.2f' % sum)
		lines.append('   Estoque Real:  %.2f' % real_stock)
		lines.append('   _______________________')			
		lines.append('   Saldo após desfazer:  %.2f' % (real_stock+sum))			
		lines.append('\n   Quantidade sendo produzida nesta ordem: %.2f' % production_qty)
		return lines
		
	return []

def _verify (self, cr, uid, data, context):
	production_id = data['ids'][0]
	production = pooler.get_pool(cr.dbname).get('mrp.production').browse(cr, uid, [production_id], [])[0]
	
	if production.state != 'confirmed':
		raise osv.except_osv('UserError','Production not confirmed!')
	
	procure_method = production.product_id.procure_method
	confirm_with_caution = False

	if procure_method == 'make_to_order':
		not_possible_fields['comment']['default']  =  '# Erro referente a demanda!\nProduções de produtos "Make to Order" não podem ser desfeitas diretamente!\nAo invés disso tente desfazer a operação (produção, venda, etc) que gerou essa produção.\n'
		return 'not_possible'

	elif procure_method == 'make_to_stock':

		move_created_ids = []
		for mov in production.move_created_ids:
			move_created_ids.append(str(mov.id))
		move_created_ids = ','.join(move_created_ids)

		alerts = _verify_demand_from_stock (cr, uid, production.product_id,  production.product_qty, move_created_ids)

		if len(alerts) > 0:
			confirm_with_caution_fields['comment']['default']  =  '# Cuidado! Há os seguintes moves previstos para esse produto:\n' + '\n'.join(alerts)
			confirm_with_caution = True

	# Verifica se existe ALGUM procurement.
	# Se não existir é uma produção velha e não pode ser desfeita sob nenhuma condição.
	cr.execute("SELECT id FROM mrp_procurement WHERE production_id=%d", [production_id])
	if cr.rowcount == 0:
		not_possible_fields['comment']['default']  = '# Erro: NENHUM procurement foi encontrado desta produção (há um erro?!).\n\nObs.: As produções criadas antes de 01/12/08 não podem ser desfeitas por essa função, e mostrarão sempre esse erro.'
		return 'not_possible'
	
	alerts = _verify_undo_production(cr, uid, production_id)
	if len(alerts) > 0:
		not_possible_fields['comment']['default']  = '# Erros referente aos insumos (Procurements):\n» Make to Order:\n' + '\n'.join(alerts)
		return 'not_possible'
	elif confirm_with_caution:
		return 'confirm_with_caution'

	return 'confirm'
	
def _verify_undo_production (cr, uid, production_id, level=0):
	production = pooler.get_pool(cr.dbname).get('mrp.production').browse(cr, uid, [production_id], [])[0]
	from_order_alerts = []
	
	# Procurements
	cr.execute("SELECT id,move_id,procure_method,product_id,product_qty,name FROM mrp_procurement WHERE production_id=%d AND NOT state IN ('draft','confirmed')", [production.id] )
	procurements = cr.dictfetchall()
	
	for procurement in procurements:
		product = _get_product(cr, uid,procurement['product_id'])
			
		# Make_to_ORDER
		if procurement['procure_method'] == 'make_to_order':
			
			if product['supply_method']  == 'buy':
				#Procurar a order de compra automática
				cr.execute("SELECT id,state,name FROM purchase_order WHERE procurement_id=%d AND EXISTS (SELECT id FROM purchase_order_line WHERE product_id=%d AND purchase_order.id = order_id) LIMIT 1",  [procurement['id'],  procurement['product_id']] )
				if cr.rowcount>0:
					purchase_order = cr.dictfetchone()
					# Ordem de compra NÃO pode ser desfeita
					if purchase_order['state']  != 'draft':
						from_order_alerts.append(' - %s (qty: %.2f): Compra "%s" não pode ser desfeita.' % (product['name'],procurement['product_qty'], purchase_order['name']))
				# Ordem de compra NÃO existe (erro?)
				else:
					from_order_alerts.append(' - %s (%.2f): Não existe ordem de compra! (O procurement foi rodado?!)' % (product['name'], procurement['product_qty']))
							
			elif product['supply_method']  == 'produce':
				#Procurar a ordem de produção automática
				cr.execute("SELECT id,state,name FROM mrp_production WHERE procurement_id=%d AND product_id=%d  LIMIT 1",  [procurement['id'],  product['id']] )
				if cr.rowcount>0:
					production_order = cr.dictfetchone()
					# Ordem de produção NÃO pode ser desfeita							
					if production_order['state'] not in ['draft', 'confirmed', 'ready']:
						from_order_alerts.append(' - %s (%.2f): Produção "%s" não pode ser desfeita.' % (product['name'], procurement['product_qty'], production_order['name']))
					# Ordem de produção pode ser desfeita
					else:
						from_order_alerts += _verify_undo_production (cr, uid, production_order['id'], level+1)

				# Ordem de produção NÃO existe (erro?)
				else:
					from_order_alerts.append(' - %s (%.2f): Não existe ordem de produção! (O procurement foi rodado?!)' % (product['name'], procurement['product_qty']))
		
	return from_order_alerts
	
not_possible_fields = {
	'comment': {'string':'Comment', 'type':'text', 'default': ''}, 
}
confirm_with_caution_fields = {
	'comment': {'string':'Comment', 'type':'text', 'default': ''}, 
}
class production_undo_states(wizard.interface):
	not_possible_form = '''<?xml version="1.0"?>
		<form string="Não é possível desfazer">
			<separator string="Essa produção não pode ser desfeita. Verifique o relatório de impedimentos:                                                                                         " colspan="4"/>
			<field name="comment" colspan="4" nolabel="1" readonly="0"/>
		</form>'''

	confirm_form = '''<?xml version="1.0"?><form string="Desfazer Confirm Production"><label string="Verificação completa. Essa ordem de produção pode ser desfeita. Deseja desfazer?"/></form>'''

	confirm_with_caution_form = '''<?xml version="1.0"?><form string="Desfazer Confirm Production"><separator string="Verificação completa. Essa ordem de produção pode ser desfeita, observando o resultado abaixo. Deseja desfazer?                   " colspan="4"/><field name="comment" colspan="4" nolabel="1" readonly="0"/></form>'''
	
	done_form = '''<?xml version="1.0"?><form string="Desfazer Confirm Production"><label string="Concluído!"/></form>'''

	states = {
		'init': {
			'actions': [],
			'result': {'type':'choice', 'next_state': _verify}
		},
		'confirm': {
			'actions': [],
			'result': {'type': 'form', 'arch':confirm_form, 'fields': {}, 'state':[('end','Cancelar'), ('ok','Confirmar Desfazer')]}
		},		
		'confirm_with_caution': {
			'actions': [],
			'result': {'type': 'form', 'arch':confirm_with_caution_form, 'fields': confirm_with_caution_fields, 'state':[('end','Cancelar'), ('ok','Confirmar Desfazer')]}
		},		
		'not_possible': {
			'actions': [],
			'result': {'type': 'form', 'arch':not_possible_form, 'fields': not_possible_fields, 'state':[('end','Fechar')]}
		}, 
		'ok': {
			'actions': [_undo_production],
			'result': {'type': 'form', 'arch':done_form, 'fields': {}, 'state':[('end','Fechar')]}
		}
	}
production_undo_states('mrp.production.undo')
